unit FileAction;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

const LC_COPY_SOURCE='Quelldatei';
      LC_COPY_DEST='Zieldatei';
      LC_MOVE_SOURCE='Original-Dateiname';
      LC_MOVE_DEST='Neuer Dateiname';

type
  TFileActionForm = class(TForm)
    PCore: TPanel;
    BClose: TButton;
    Core: TListBox;
    PLegend: TPanel;
    LLegend2: TLabel;
    LLegend1: TLabel;
    LLegend0: TLabel;
    Header: TPaintBox;
    PProgress: TProgressBar;
    LProgress: TLabel;
    NProgress: TLabel;
    procedure BCloseClick(Sender: TObject);
    procedure CoreDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HeaderPaint(Sender: TObject);
  private
    { Private declarations }
    MaxWidth:integer;
    HW:integer;
    MoveMode:boolean;
  public
    { Public declarations }
    procedure ShowEx(_MoveMode:boolean);
  end;

var
  FileActionForm: TFileActionForm;

implementation

uses Main, m3uCore;

{$R *.dfm}

procedure TFileActionForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFileActionForm.CoreDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var s:string; i,TW:integer;
begin
  with Core,Canvas do begin
    Brush.Color:=clWindow;
    FillRect(Rect);
    s:=Items[Index];
    if s[1]='0' then Font.Color:=clRed else Font.Color:=$6000;
    i:=pos('|',s);
    TW:=TextWidth(copy(s,2,i-2));
    if TW>MaxWidth then begin
      MaxWidth:=TW;
      Core.Invalidate;
      Header.Invalidate;
    end;
    TextOut(Rect.Left+2,Rect.Top+1,copy(s,2,i-2));
    Pen.Color:=cl3DLight;
    MoveTo(Rect.Left+4+TW,Rect.Top+11);
    LineTo(Rect.Left+MaxWidth+17,Rect.Top+11);
    TextOut(Rect.Left+MaxWidth+20,Rect.Top+1,copy(s,i+1,length(s)-i));
  end;
end;

procedure TFileActionForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MainForm.Close;
end;

procedure TFileActionForm.ShowEx(_MoveMode:boolean);
begin
  Core.Items.Clear;
  PProgress.Position:=0;
  PProgress.Max:=ItemCount;
  NProgress.Caption:='0%';
  BClose.Enabled:=false;
  MaxWidth:=0;
  MoveMode:=_MoveMode;
  with Header do begin
    Font.Style:=[fsBold];
    Canvas.Font.Style:=[fsBold];
    if MoveMode then HW:=Canvas.TextWidth(LC_MOVE_SOURCE)
                else HW:=Canvas.TextWidth(LC_COPY_SOURCE);
  end;
  Show;
end;

procedure TFileActionForm.HeaderPaint(Sender: TObject);
begin
  with Header.Canvas do begin
    if MoveMode then TextOut(2,1,LC_MOVE_SOURCE)
                else TextOut(2,1,LC_COPY_SOURCE);
    Pen.Color:=cl3DLight;
    MoveTo(HW+4,11);
    LineTo(MaxWidth+17,11);
    if MoveMode then TextOut(MaxWidth+20,1,LC_MOVE_DEST)
                else TextOut(MaxWidth+20,1,LC_COPY_DEST);
    Pen.Color:=0;
    MoveTo(0,16); LineTo(Width,16);
  end;
end;

end.
