unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, m3uCore, StdCtrls, ExtCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    OpenList: TOpenDialog;
    BoxInfo: TBevel;
    LCapInfo: TLabel;
    LListFile: TLabel;
    LLength: TLabel;
    LIsEXTM3u: TLabel;
    BRemoveEXTM3U: TButton;
    BCreateEXTM3U: TButton;
    BRenameFiles: TButton;
    BCopyFiles: TButton;
    BCancel: TButton;
    BoxCopy: TBevel;
    LDestFolder: TLabel;
    EDestFolder: TEdit;
    CBEnumerate: TCheckBox;
    Star2: TLabel;
    Star1: TLabel;
    Star3: TLabel;
    BoxEnumerate: TBevel;
    Label1: TLabel;
    LDigits: TLabel;
    EDigits: TEdit;
    CDigits: TUpDown;
    LEnumExplanation: TLabel;
    CBCopyUseTitles: TCheckBox;
    BMoveFiles: TButton;
    Label2: TLabel;
    BSelectDir: TButton;
    SelectDir: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BCancelClick(Sender: TObject);
    procedure BRemoveEXTM3UClick(Sender: TObject);
    procedure CBEnumerateClick(Sender: TObject);
    procedure CDigitsClick(Sender: TObject; Button: TUDBtnType);
    procedure EDigitsChange(Sender: TObject);
    procedure BCreateEXTM3UClick(Sender: TObject);
    procedure BRenameFilesClick(Sender: TObject);
    procedure BCopyFilesClick(Sender: TObject);
    procedure BMoveFilesClick(Sender: TObject);
    procedure BSelectDirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses FileAction;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ListFile:=ParamStr(1);
//SetCurrentDirectory('E:\Ablage');
//ListFile:='_THE_LIST.m3u';
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
//
end;

procedure TMainForm.FormShow(Sender: TObject);
var Attr:integer;
    h,m,s:integer;
    IsRO:boolean;
var P:TPoint;
begin
  if ListFile='' then begin
    if OpenList.Execute
      then ListFile:=OpenList.FileName
      else Close;
  end;
  Attr:=GetFileAttributes(PChar(ListFile));
  if Attr<0 then begin
    ShowMessage('Die angegebene Datei existiert nicht!');
    Close;
  end;
  IsRO:=(Attr AND FILE_ATTRIBUTE_READONLY<>0);
  if IsRO then
    ShowMessage('Die Playlist ist schreibgeschtzt.'^M+
                'Alle Optionen, welche die Playlist selbst verndern,'^M+
                'werden deaktiviert.');
  if not ReadList then begin
    ShowMessage('Die Playlist ist keine gltige EXTM3U-Playliste!');
    Close;
  end;
  LListFile.Caption:=ListFile;
  if IsEXTM3U then begin
    LIsEXTM3U.Caption:='(EXTM3U)';
    s:=Duration MOD 60;
    m:=(Duration DIV 60) MOD 60;
    h:=Duration DIV 3600;
    if h>0 then LLength.Caption:=IntToStr(ItemCount)+' Titel, '+IntToStr(h)+':'+
                                 char(48+m DIV 10)+char(48+m MOD 10)+':'+
                                 char(48+s DIV 10)+char(48+s MOD 10)+' h'
           else LLength.Caption:=IntToStr(ItemCount)+' Titel, '+IntToStr(m)+':'+
                                 char(48+s DIV 10)+char(48+s MOD 10)+' min';
  end else
    LLength.Caption:=IntToStr(ItemCount)+' Titel';
  BRemoveEXTM3U.Enabled:=not(IsRO) AND IsEXTM3U;
  BCreateEXTM3U.Enabled:=not(IsRO) AND not(IsEXTM3U);
  BRenameFiles.Enabled:=IsEXTM3U;
  CBCopyUseTitles.Enabled:=IsEXTM3U;
  GetCursorPos(P);
  Left:=P.X-Width DIV 2; Top:=P.Y-Height DIV 2;
  if Left<0 then Left:=0;
  if Top<0 then Top:=0;
  if Left+Width>Screen.Width then Left:=Screen.Width-Width;
  if Top+Height>Screen.Height then Top:=Screen.Height-Height;
  EDestFolder.Text:=GetCurrentDir;
end;

procedure TMainForm.BCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.BRemoveEXTM3UClick(Sender: TObject);
begin
  RemoveEXTM3U;
  Close;
end;

procedure TMainForm.CBEnumerateClick(Sender: TObject);
begin
  if CBEnumerate.Checked
    then EnumDigits:=CDigits.Position
    else EnumDigits:=0;
end;

procedure TMainForm.CDigitsClick(Sender: TObject; Button: TUDBtnType);
begin
  if CBEnumerate.Checked then EnumDigits:=CDigits.Position
end;

procedure TMainForm.EDigitsChange(Sender: TObject);
begin
  if CBEnumerate.Checked then EnumDigits:=CDigits.Position
end;

procedure TMainForm.BCreateEXTM3UClick(Sender: TObject);
begin
  CreateEXTM3U;
  Close;
end;

procedure TMainForm.BRenameFilesClick(Sender: TObject);
begin
  Hide;
  FileActionForm.ShowEx(true);
  RenameFiles;
end;

procedure TMainForm.BCopyFilesClick(Sender: TObject);
begin
  Hide;
  FileActionForm.ShowEx(false);
  CopyFiles(IncludeTrailingPathDelimiter(EDestFolder.Text),CBCopyUseTitles.Checked);
end;

procedure TMainForm.BMoveFilesClick(Sender: TObject);
begin
  Hide;
  FileActionForm.ShowEx(false);
  MoveFiles(IncludeTrailingPathDelimiter(EDestFolder.Text),CBCopyUseTitles.Checked);
end;

procedure TMainForm.BSelectDirClick(Sender: TObject);
begin
  SelectDir.InitialDir:=EDestFolder.Text;
  SelectDir.FileName:='(Dateiname ist egal)';
  if SelectDir.Execute then EDestFolder.Text:=ExtractFilePath(SelectDir.FileName);
end;

end.
