unit m3uCore;
interface
uses SysUtils, Forms, Windows;

const LISTGRANULARITY=128;
type TListItem=record
                 FileName,Title:shortstring;
               end;
var TheList:array of TListItem;

var ListFile:string;
    ItemCount,Duration:integer;
    IsEXTM3U:boolean;
var EnumDigits:integer;

function ReadList:boolean;
function GetEnum(i:integer):string;
procedure AddToFileList(const Source,Dest:string;Lazy,Successful:boolean);
procedure FinishFileAction;

procedure RemoveEXTM3U;
procedure CreateEXTM3U;
procedure RenameFiles;
procedure CopyFiles(const DestPath:string;UseTitles:boolean);
procedure MoveFiles(const DestPath:string;UseTitles:boolean);

implementation
uses FileAction;

function ReadList:boolean;
var t:text; s:string; i,r:integer;
    NextTitle:shortstring;
begin
  ReadList:=false;
  SetLength(TheList,0);
  ItemCount:=0; Duration:=0; IsEXTM3U:=false;
  NextTitle:='';
  AssignFile(t,ListFile); Reset(t);
  while not EOF(t) do begin
    readln(t,s);
    if s='[playlist]' then begin
      // PLS-Playlist ==> raus!
      CloseFile(t); exit;
    end else if s='#EXTM3U' then
      IsEXTM3U:=true
    else if copy(s,1,8)='#EXTINF:' then begin
      i:=pos(',',s);
      if i<1 then i:=8;
      NextTitle:=copy(s,i+1,length(s)-i);
      if i>9 then begin
        val(copy(s,9,i-9),i,r);
        if r=0 then inc(Duration,i);
      end;
    end else if length(s)>MAX_PATH then begin
      // zu langer "Dateiname" deutet auf Binrfile hin ==> raus!
      CloseFile(t); exit;
    end else begin
      // Dateiname auf Binrzeichen prfen
      for i:=1 to length(s) do
        if s[i] IN [#0..#9,#11,#12,#14..#31,'?','*','>','<','|'] then begin
          CloseFile(t); exit;
        end;
      // Alles OK => Titel eintragen
      if ItemCount>High(TheList) then
        SetLength(TheList,length(TheList)+LISTGRANULARITY);
      TheList[ItemCount].FileName:=Trim(s);
      TheList[ItemCount].Title:=Trim(NextTitle);
      inc(ItemCount);
      NextTitle:='';
    end;
  end;
  CloseFile(t);
  SetLength(TheList,ItemCount);
  ReadList:=true;
end;

function GetEnum(i:integer):string;
var j:integer;
begin
  if EnumDigits=0 then
    Result:=''
  else begin
    str(i+1:EnumDigits,Result);
    for j:=1 to length(Result) do
      if Result[j]=#32 then Result[j]:='0';
    Result:=Result+#32;
  end;
end;

procedure AddToFileList(const Source,Dest:string;Lazy,Successful:boolean);
begin
  with FileActionForm.Core do begin
    Items.Add(char(byte(Successful)+48)+Source+'|'+Dest);
    if not(Lazy) OR not(Successful) then ItemIndex:=Items.Count-1;
  end;
  FileActionForm.PProgress.StepIt;
  Application.ProcessMessages;
end;

procedure FinishFileAction;
begin
  with FileActionForm.Core do begin
    ItemIndex:=Items.Count-1;
    Invalidate;
  end;
  FileActionForm.NProgress.Caption:='Fertig';
  FileActionForm.BClose.Enabled:=true;
end;

{$I RemoveEXTM3U.m3uaction.inc.pas}
{$I CreateEXTM3U.m3uaction.inc.pas}
{$I RenameFiles.m3uaction.inc.pas}
{$I CopyFiles.m3uaction.inc.pas}
{$I MoveFiles.m3uaction.inc.pas}

initialization
  SetLength(TheList,0);
  ItemCount:=0; Duration:=0; IsEXTM3U:=false;
  EnumDigits:=0;
finalization
  Finalize(TheList);
end.
